
class DAO():
    def __init__(self, fname, mode):
        DAO.filename = fname
        DAO.mode = mode
        DAO.file = open(DAO.filename, DAO.mode)

    def __str__(self):
        if DAO.mode == "r":
            typ = "Read"
        elif DAO.mode == "w":
            typ = "Write"     
        else:
            typ = "Undefined"  
        string = 'DAO: ' + str(typ) + ' \'' + str(DAO.filename) + '\'\n'
        string += "\tfile: " + str(DAO.file) + "\n"
        return string
    
    def reset(self):
        DAO.file.seek(0, 0)

    def close(self):
        DAO.file.close()

class ReadFile(DAO):
    def __init__(self, filename):
        DAO.__init__(DAO, filename, "r")

    def read(self, ch):
        return DAO.file.read(ch)
        
    def readline(self):
        return DAO.file.readline()
    
    def readlines(self):
        return DAO.file.readlines()
    
    def readall(self):
        string = ""
        for line in DAO.file:
            string += line
        return string
    
    def readsubstr(self, start, stop):
        DAO.file.seek(start)
        return DAO.file.read(stop - start)
    
class WriteFile(DAO):
    def __init__(self, filename):
        DAO.__init__(DAO, filename, "w")
        
    def writeLine(self, txt):
        DAO.file.write(txt + "\n")
    
#def main():
#    dao = ReadFile('test.txt')
#    print(repr(dao))
#    print(str(dao))
#    print(dao.readsubstr(10, 30))

#main()